<?php
class ControllerCountry extends Controller {
	var $error = array();

	function index() {
		$response =& $this->locator->get('response');
		$language =& $this->locator->get('language');
		$template =& $this->locator->get('template');
		$module   =& $this->locator->get('module');

		$language->load('controller/country.php');

		$template->set('title', $language->get('heading_title'));

		$template->set('content', $this->getList());

		$template->set($module->fetch());

		$response->set($template->fetch('layout.tpl'));
	}

	function insert() {
		$request  =& $this->locator->get('request');
		$response =& $this->locator->get('response');
		$database =& $this->locator->get('database');
		$url      =& $this->locator->get('url');
		$language =& $this->locator->get('language');
		$template =& $this->locator->get('template');
		$session  =& $this->locator->get('session');
		$module   =& $this->locator->get('module');
		$cache    =& $this->locator->get('cache');

		$language->load('controller/country.php');

		$template->set('title', $language->get('heading_title'));

		if ($request->isPost() && $request->has('name', 'post') && $this->validateForm()) {
			$sql = "insert into country set name = '?', iso_code_2 = '?', iso_code_3 = '?', address_format = '?', status = '1'";
			$database->query($database->parse($sql, $request->gethtml('name', 'post'), $request->gethtml('iso_code_2', 'post'), $request->gethtml('iso_code_3', 'post'), $request->gethtml('address_format', 'post')));
			
			$cache->delete('country');
			
			$session->set('message', $language->get('text_message'));

			$response->redirect($url->ssl('country'));
		}

		$template->set('content', $this->getForm());

		$template->set($module->fetch());

		$response->set($template->fetch('layout.tpl'));
	}

	function update() {
		$request  =& $this->locator->get('request');
		$response =& $this->locator->get('response');
		$database =& $this->locator->get('database');
		$url      =& $this->locator->get('url');
		$language =& $this->locator->get('language');
		$template =& $this->locator->get('template');
		$session  =& $this->locator->get('session');
		$module   =& $this->locator->get('module');
		$cache    =& $this->locator->get('cache');

		$language->load('controller/country.php');

		$template->set('title', $language->get('heading_title'));

		if ($request->isPost() && $request->has('name', 'post') && $this->validateForm()) {
			$sql = "update country set name = '?', iso_code_2 = '?', iso_code_3 = '?', address_format = '?', status = '1' where country_id = '?'";
			$database->query($database->parse($sql, $request->gethtml('name', 'post'), $request->gethtml('iso_code_2', 'post'), $request->gethtml('iso_code_3', 'post'), $request->gethtml('address_format', 'post'), $request->gethtml('country_id')));

			$cache->delete('country');
			
			$session->set('message', $language->get('text_message'));

			$response->redirect($url->ssl('country'));
		}

		$template->set('content', $this->getForm());

		$template->set($module->fetch());

		$response->set($template->fetch('layout.tpl'));
	}
 
 	function listAction() {
    	$request  =& $this->locator->get('request');
		$response =& $this->locator->get('response');
		$database =& $this->locator->get('database');
		$url      =& $this->locator->get('url');
		$language =& $this->locator->get('language');
		$template =& $this->locator->get('template');
		$session  =& $this->locator->get('session');
		$module   =& $this->locator->get('module');
		$cache    =& $this->locator->get('cache');

    	$language->load('controller/country.php');

    	$template->set('title', $language->get('heading_title'));
	
    	if (($request->has('listitem', 'post')) && ($this->validateAction())) {
      		foreach ($request->gethtml('listitem', 'post') as $country_id) {
      			
      			if ($request->gethtml('listcmd', 'post') == $language->get('select_delete'))  {
      				
      				$request->set('country_id', $country_id); // Set for validateDelete function
      				
      				if (!$this->validateDelete()) {
      					$template->set('content', $this->getList());
						$template->set($module->fetch());
		   				$response->set($template->fetch('layout.tpl'));
		   				$cache->delete('country');
		   				return;
					}
					
      				$database->query("delete from country where country_id = '".$country_id."'");
	  				$session->set('message', $language->get('text_delete_message'));
				
				} elseif ($request->gethtml('listcmd', 'post') == $language->get('select_toggle')) { 

					$result = $database->getRow("select status from country where `country_id` = '" . $country_id . "'"); 
					$sql = "update country set status = '?' where country_id = '?'";
      				$database->query($database->parse($sql, ($result['status'] == 1) ? 0 : 1, $country_id));
					$session->set('message', $language->get('text_status_message'));
				}
			}
			
			$session->set('message', $language->get('text_message'));
			
	  		$cache->delete('country');
	  		
	  		$response->redirect($url->ssl('country'));
    	}
    
    	$template->set('content', $this->getList());
	
		$template->set($module->fetch());
	
    	$response->set($template->fetch('layout.tpl'));
  	}
 
	function delete() {
		$request  =& $this->locator->get('request');
		$response =& $this->locator->get('response');
		$database =& $this->locator->get('database');
		$url      =& $this->locator->get('url');
		$language =& $this->locator->get('language');
		$template =& $this->locator->get('template');
		$session  =& $this->locator->get('session');
		$module   =& $this->locator->get('module');
		$cache    =& $this->locator->get('cache');

		$language->load('controller/country.php');

		$template->set('title', $language->get('heading_title'));

		if (($request->gethtml('country_id')) && ($this->validateDelete())) {
			$database->query("delete from country where country_id = '" . (int)$request->gethtml('country_id') . "'");

			$cache->delete('country');
			
			$session->set('message', $language->get('text_message'));

			$response->redirect($url->ssl('country'));
		}

		$template->set('content', $this->getList());

		$template->set($module->fetch());

		$response->set($template->fetch('layout.tpl'));
	}

	function getList() {
		$request  =& $this->locator->get('request');
		$database =& $this->locator->get('database');
		$config   =& $this->locator->get('config');
		$url      =& $this->locator->get('url');
		$language =& $this->locator->get('language');
		$session  =& $this->locator->get('session');
		$template =& $this->locator->get('template');

		$cols = array();

		$cols[] = array(
			'name'  => $language->get('column_name'),
			'sort'  => 'name',
			'href'  => $url->ssl('country', 'page', array('sort' => 'name', 'order' => ($request->gethtml('order') == 'desc') ? 'asc' : 'desc')),
			'align' => 'left'
		);

		$cols[] = array(
			'name'  => $language->get('column_iso_code_2'),
			'sort'  => 'iso_code_2',
			'href'  => $url->ssl('country', 'page', array('sort' => 'iso_code_2', 'order' => ($request->gethtml('order') == 'desc') ? 'asc' : 'desc')),
			'align' => 'left'
		);

		$cols[] = array(
			'name'  => $language->get('column_iso_code_3'),
			'sort'  => 'iso_code_3',
			'href'  => $url->ssl('country', 'page', array('sort' => 'iso_code_3', 'order' => ($request->gethtml('order') == 'desc') ? 'asc' : 'desc')),
			'align' => 'left'
		);

    	$cols[] = array(
      		'name'  => $language->get('column_action'),
      		'align' => 'right'
    	);
    	
    	$cols[] = array(
        	'name' => '<input type="checkbox" name="checkall" onclick="$(\'input[name*=listitem]\').attr(\'checked\', this.checked);" />',
            'align' => 'right'
        );
				
		if (!$session->get('country.search')) {
			$sql = "select country_id, name, iso_code_2, iso_code_3, status from country";
		} else {
			$sql = "select country_id, name, iso_code_2, iso_code_3, status from country where name like '?' or iso_code_2 like '?' or iso_code_3 like '?'";
		}

		$sort = array(
			'name',
			'iso_code_2',
			'iso_code_3'
		);

		if (in_array($session->get('country.sort'), $sort)) {
			$sql .= " order by " . $session->get('country.sort') . " " . (($session->get('country.order') == 'desc') ? 'desc' : 'asc');
		} else {
			$sql .= " order by name asc";
		}

		$results = $database->getRows($database->splitQuery($database->parse($sql, '%' . $session->get('country.search') . '%', $session->get('country.search'), $session->get('country.search')), $session->get('country.page'), ($request->gethtml('max_rows')) ? $request->gethtml('max_rows') : $config->get('config_max_rows')));

		$rows = array();

		foreach ($results as $result) {
			$cell = array();

			$cell[] = array(
				'value'   => $result['name'],
				'align'   => 'left',
				'default' => ($result['country_id'] == $config->get('config_country_id'))
			);

			$cell[] = array(
				'value' => $result['iso_code_2'],
				'align' => 'left'
			);

			$cell[] = array(
				'value' => $result['iso_code_3'],
				'align' => 'left'
			);

			$action = array();
      		
			$action[] = array(
        		'icon' => 'update.png',
				'text' => $language->get('button_update'),
				'href' => $url->ssl('country', 'update', array('country_id' => $result['country_id']))
      		);
						
			$action[] = array(
        		'icon' => ($result['status'] ? 'enabled.png' : 'disabled.png'),
				'text' => $language->get('button_status'),
				'href' => $url->ssl('country', 'toggleStatus', array('country_id' => $result['country_id']))
      		);
      		
      		$action[] = array(
        		'icon' => 'delete.png',
				'text' => $language->get('button_delete'),
				'href' => $url->ssl('country', 'delete', array('country_id' => $result['country_id']))
      		);

      		$cell[] = array(
        		'action' => $action,
        		'align'  => 'right'
      		);
      		
      		$cell[] = array(
            	'value' => '<input type="checkbox" name="listitem[]" value="' . $result['country_id'] . '" />',
            	'align' => 'right'
        	);
						
			$rows[] = array('cell' => $cell);
		}

		$view = $this->locator->create('template');

		$view->set('tpl', $template);

		$view->set('heading_title', $language->get('heading_title'));
		$view->set('heading_description', $language->get('heading_description'));

		$view->set('text_default', $language->get('text_default'));
		$view->set('text_results', $language->get('text_results', $database->getFrom(), $database->getTo(), $database->getTotal()));

		$view->set('select_toggle', $language->get('select_toggle'));
		$view->set('select_delete', $language->get('select_delete'));
		
		$view->set('entry_page', $language->get('entry_page'));
		$view->set('entry_search', $language->get('entry_search'));

		$view->set('button_insert', $language->get('button_insert'));
		$view->set('button_update', $language->get('button_update'));
		$view->set('button_delete', $language->get('button_delete'));
		$view->set('button_status', $language->get('button_status'));
 
 		$view->set('action', $url->ssl('country', 'page'));
 
 		$view->set('insert', $url->ssl('country', 'insert'));
 
		$view->set('error', @$this->error['message']);

		$view->set('message', $session->get('message'));
		
		$session->delete('message');
		
		$view->set('listaction', $url->ssl('country', 'listAction'));
		
		$view->set('colspan', count($cols));
		
		$view->set('selectbox', array(
			$language->get('select_toggle'),
			$language->get('select_delete')
		));

		$view->set('search', $session->get('country.search'));
		
		$session->delete('country.search');
		
		$view->set('sort', $session->get('country.sort'));
		$view->set('order', $session->get('country.order'));
		$view->set('page', $session->get('country.page'));

		$view->set('cols', $cols);
		$view->set('rows', $rows);

		$page_data = array();

		for ($i = 1; $i <= $database->getPages(); $i++) {
			$page_data[] = array(
				'text'  => $language->get('text_pages', $i, $database->getPages()),
				'value' => $i
			);
		}

		$view->set('pages', $page_data);

		return $view->fetch('content/list.tpl');
	}

	function getForm() {
		$request  =& $this->locator->get('request');
		$database =& $this->locator->get('database');
		$url      =& $this->locator->get('url');
		$language =& $this->locator->get('language');
		$template =& $this->locator->get('template');

		$view = $this->locator->create('template');

		$view->set('tpl', $template);

		$view->set('heading_title', $language->get('heading_title'));
		$view->set('heading_description', $language->get('heading_description'));

		$view->set('entry_name', $language->get('entry_name'));
		$view->set('entry_iso_code_2', $language->get('entry_iso_code_2'));
		$view->set('entry_iso_code_3', $language->get('entry_iso_code_3'));
		$view->set('entry_address_format', $language->get('entry_address_format'));

		$view->set('button_save', $language->get('button_save'));
		$view->set('button_cancel', $language->get('button_cancel'));

		$view->set('action', $url->ssl('country', $request->gethtml('action'), array('country_id' => $request->gethtml('country_id'))));
		
		$view->set('tab_general', $language->get('tab_general'));

		$view->set('error', @$this->error['message']);
		$view->set('error_name', @$this->error['name']);

		$view->set('cancel', $url->ssl('country'));

		if (($request->gethtml('country_id')) && (!$request->isPost())) {
			$country_info = $database->getRow("select distinct * from country where country_id = '" . (int)$request->gethtml('country_id') . "'");
		}

		if ($request->has('name', 'post')) {
			$view->set('name', $request->gethtml('name', 'post'));
		} else {
			$view->set('name', @$country_info['name']);
		}

		if ($request->has('iso_code_2', 'post')) {
			$view->set('iso_code_2', $request->gethtml('iso_code_2', 'post'));
		} else {
			$view->set('iso_code_2', @$country_info['iso_code_2']);
		}

		if ($request->has('iso_code_3', 'post')) {
			$view->set('iso_code_3', $request->gethtml('iso_code_3', 'post'));
		} else {
			$view->set('iso_code_3', @$country_info['iso_code_3']);
		}

		if ($request->has('address_format', 'post')) {
			$view->set('address_format', $request->gethtml('address_format', 'post'));
		} else {
			$view->set('address_format', @$country_info['address_format']);
		}

		return $view->fetch('content/country.tpl');
	}

	function validateForm() {
		$request  =& $this->locator->get('request');
		$language =& $this->locator->get('language');
		$user     =& $this->locator->get('user');
        $validate =& $this->locator->get('validate');

		if (!$user->hasPermission('modify', 'country')) {
			$this->error['message'] = $language->get('error_permission');
		}

        if (!$validate->strlen($request->gethtml('name', 'post'),1,32)) {
			$this->error['name'] = $language->get('error_name');
		}

		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}
	}

	function validateAction() {
		$language =& $this->locator->get('language');
		$user     =& $this->locator->get('user');  
    
    	if (!$user->hasPermission('modify', 'country')) {
      		$this->error['message'] = $language->get('error_permission');  
    	}
	  	
		if (!$this->error) {
	  		return TRUE;
		} else {
	  		return FALSE;
		}
  	}
	
	function validateDelete() {
		$request  =& $this->locator->get('request');
		$database =& $this->locator->get('database');
		$config   =& $this->locator->get('config');
		$language =& $this->locator->get('language');
		$user     =& $this->locator->get('user');

		if (!$user->hasPermission('modify', 'country')) {
			$this->error['message'] = $language->get('error_permission');
		}

		if ($config->get('config_country_id') == $request->gethtml('country_id')) {
			$this->error['message'] = $language->get('error_default');
		}

		$address_info = $database->getRow("select count(*) as total from address where country_id = '" . (int)$request->gethtml('country_id') . "'");

		if ($address_info['total']) {
			$this->error['message'] = $language->get('error_address', $address_info['total']);
		}

		$address_info = $database->getRow("select count(*) as total from address where country_id = '" . (int)$request->gethtml('country_id') . "'");

		if ($address_info['total']) {
			$this->error['message'] = $language->get('error_address', $address_info['total']);
		}

		$zone_info = $database->getRow("select count(*) as total from zone where country_id = '" . (int)$request->gethtml('country_id') . "'");

		if ($zone_info['total']) {
			$this->error['message'] = $language->get('error_zone', $zone_info['total']);
		}

		$zone_to_geo_zone_info = $database->getRow("select count(*) as total from zone_to_geo_zone where country_id = '" . (int)$request->gethtml('country_id') . "'");

		if ($zone_to_geo_zone_info['total']) {
			$this->error['message'] = $language->get('error_zone_to_geo_zone', $zone_to_geo_zone_info['total']);
		}

		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}
	}
	
	function page() {
		$request  =& $this->locator->get('request');
		$response =& $this->locator->get('response');
		$url      =& $this->locator->get('url');
		$session  =& $this->locator->get('session');

		if ($request->has('search', 'post')) {
			$session->set('country.search', $request->gethtml('search', 'post'));
		}

		if (($request->has('page', 'post')) || ($request->has('search', 'post'))) {
			$session->set('country.page', $request->gethtml('page', 'post'));
		}

		if ($request->has('order')) {
			$session->set('country.order', (($session->get('country.sort') == $request->gethtml('sort')) && ($session->get('country.order') == 'asc')) ? 'desc' : 'asc');
		}

		if ($request->has('sort')) {
			$session->set('country.sort', $request->gethtml('sort'));
		}

		$response->redirect($url->ssl('country'));
	}	
	
	function toggleStatus() {
		$request  =& $this->locator->get('request');
		$response =& $this->locator->get('response');
		$database =& $this->locator->get('database');
		$url      =& $this->locator->get('url');
		$language =& $this->locator->get('language');
		$template =& $this->locator->get('template');
		$session  =& $this->locator->get('session');
		$module   =& $this->locator->get('module');
		$cache    =& $this->locator->get('cache');
		
		$language->load('controller/country.php');
		
		$result = $database->getRow("select status from country where `country_id` = '" . $request->gethtml('country_id') . "'"); 
		$sql = "update country set status = '?' where country_id = '?'";
      	$database->query($database->parse($sql, ($result['status'] == 1) ? 0 : 1, $request->gethtml('country_id')));
		
		$cache->delete('country');
	  		
		$session->set('message', $language->get('text_status_message'));
		$response->redirect($url->ssl('country'));     		
		
	}
}
?>
