<?php
class ControllerModuleCatalogBest extends Controller {
	var $error = array();
	 
	function index() { 
		$database =& $this->locator->get('database');
		$language =& $this->locator->get('language');
		$module   =& $this->locator->get('module');
		$request  =& $this->locator->get('request');
		$response =& $this->locator->get('response');
		$template =& $this->locator->get('template');
		$session  =& $this->locator->get('session');
		$url      =& $this->locator->get('url');
		
		$language->load('controller/module_catalog_best.php');

		$template->set('title', $language->get('heading_title'));

		if (($request->isPost()) && ($this->validate())) {
			$database->query("delete from setting where type = 'catalog' and `group` = 'best'");
			
			$database->query($database->parse("insert into setting set type = 'catalog', `group` = 'best', `key` = 'best_status', `value` = '?'", $request->get('catalog_best_status', 'post')));
			$database->query($database->parse("insert into setting set type = 'catalog', `group` = 'best', `key` = 'best_max_rows', `value` = '?'", $request->gethtml('catalog_best_max_rows', 'post')));
			//$database->query($database->parse("insert into setting set type = 'catalog', `group` = 'best', `key` = 'best_ajaxadd', `value` = '?'", $request->gethtml('catalog_best_ajaxadd', 'post')));
			
			$session->set('message', $language->get('text_message'));
			
			$response->redirect($url->ssl('extension', FALSE, array('type' => 'module')));
		}
		
		$view = $this->locator->create('template');

		$view->set('tpl', $template);
		
		$view->set('heading_title', $language->get('heading_title'));
		$view->set('heading_description', $language->get('heading_description'));

		$view->set('text_enabled', $language->get('text_enabled'));
		$view->set('text_disabled', $language->get('text_disabled'));
		
		$view->set('entry_status', $language->get('entry_status'));
		$view->set('entry_max_rows', $language->get('entry_max_rows'));
		$view->set('entry_ajax_add', $language->get('entry_ajax_add'));
		
		$view->set('button_save', $language->get('button_save'));
		$view->set('button_cancel', $language->get('button_cancel'));

		$view->set('tab_general', $language->get('tab_general'));

		$view->set('error', @$this->error['message']);

		$view->set('action', $url->ssl('module_catalog_best'));

		$view->set('list', $url->ssl('extension', FALSE, array('type' => 'module')));

		$view->set('cancel', $url->ssl('extension', FALSE, array('type' => 'module')));	

		if (!$request->isPost()) {
			$results = $database->getRows("select * from setting where type = 'catalog' and `group` = 'best'");
			
			foreach ($results as $result) {
				$setting_info[$result['type']][$result['key']] = $result['value'];
			}
		}

		if ($request->has('catalog_best_status', 'post')) {
			$view->set('catalog_best_status', $request->get('catalog_best_status', 'post'));
		} else {
			$view->set('catalog_best_status', @$setting_info['catalog']['best_status']);
		}
		
		if ($request->has('catalog_best_max_rows', 'post')) {
			$view->set('catalog_best_max_rows', $request->get('catalog_best_max_rows', 'post'));
		} else {
			$view->set('catalog_best_max_rows', isset($setting_info['catalog']['special_max_rows'])?$setting_info['catalog']['best_max_rows']:6);
		}
		
		//if ($request->has('catalog_best_ajaxadd', 'post')) {
		//	$view->set('catalog_best_ajaxadd', $request->gethtml('catalog_best_ajaxadd', 'post'));
		//} else {
		//	$view->set('catalog_best_ajaxadd', isset($setting_info['catalog']['best_ajaxadd']));
		//}

		$template->set('content', $view->fetch('content/module_catalog_best.tpl'));

		$template->set($module->fetch());

		$response->set($template->fetch('layout.tpl'));
	}

	function validate() {
		$language =& $this->locator->get('language');
		$user     =& $this->locator->get('user');

		if (!$user->hasPermission('modify', 'module_catalog_best')) {
			$this->error['message'] = $language->get('error_permission');
		}

		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}
	}

	function install() {
		$database =& $this->locator->get('database');
		$language =& $this->locator->get('language');
		$response =& $this->locator->get('response');
		$session  =& $this->locator->get('session');
		$url      =& $this->locator->get('url');
		$user     =& $this->locator->get('user');

		$language->load('controller/module_catalog_best.php');
		
		if ($user->hasPermission('modify', 'module_catalog_best')) {
			$database->query("delete from setting where type = 'catalog' and `group` = 'best'");
			
			$database->query("insert into setting set type = 'catalog', `group` = 'best', `key` = 'best_status', value = '1'");
			$database->query("insert into setting set type = 'catalog', `group` = 'best', `key` = 'best_max_rows', value = '6'");
			//$database->query("insert into setting set type = 'catalog', `group` = 'best', `key` = 'best_ajaxadd', value = '1'");
			
			$session->set('message', $language->get('text_message'));
		} else {
			$session->set('error', $language->get('error_permission'));
		}	
				
		$response->redirect($url->ssl('extension', FALSE, array('type' => 'module')));	
	}

	function uninstall() {
		$database =& $this->locator->get('database');
		$language =& $this->locator->get('language');
		$response =& $this->locator->get('response');
		$session  =& $this->locator->get('session');
		$url      =& $this->locator->get('url');
		$user     =& $this->locator->get('user');
		
		$language->load('controller/module_catalog_best.php');

		if ($user->hasPermission('modify', 'module_catalog_best')) {
			$database->query("delete from setting where type = 'catalog' and `group` = 'best'");
			
			$session->set('message', $language->get('text_message'));
		} else {
			$session->set('error', $language->get('error_permission'));
		}	

		$response->redirect($url->ssl('extension', FALSE, array('type' => 'module')));
	}
}
?>
