<?php
class ControllerModuleCatalogWelcome extends Controller {
	var $error = array();
	 
	function index() { 
		$database =& $this->locator->get('database');
		$language =& $this->locator->get('language');
		$module   =& $this->locator->get('module');
		$request  =& $this->locator->get('request');
		$response =& $this->locator->get('response');
		$template =& $this->locator->get('template');
		$session  =& $this->locator->get('session');
		$url      =& $this->locator->get('url');
		
		$language->load('controller/module_catalog_welcome.php');

		$template->set('title', $language->get('heading_title'));
				
		if ($request->isPost() && $request->has('catalog_welcome_status', 'post') && $this->validate()) {
			$database->query("delete from setting where type = 'catalog' and `group` = 'welcome'");
			
			$database->query($database->parse("insert into setting set type = 'catalog', `group` = 'welcome', `key` = 'welcome_status', `value` = '?'", $request->gethtml('catalog_welcome_status', 'post')));
			$database->query($database->parse("insert into setting set type = 'catalog', `group` = 'welcome', `key` = 'welcome_text_logged', `value` = '?'", $request->get('catalog_welcome_text_logged', 'post')));
			$database->query($database->parse("insert into setting set type = 'catalog', `group` = 'welcome', `key` = 'welcome_text_greeting', `value` = '?'", $request->get('catalog_welcome_text_greeting', 'post')));
			
			$session->set('message', $language->get('text_message'));
			
			$response->redirect($url->ssl('extension', FALSE, array('type' => 'module')));
		}
		
		$view = $this->locator->create('template');

		$view->set('tpl', $template);
		
		$editor = $this->locator->create('template');
		$view->set('editor',$editor->fetch('content/editor.tpl'));
		
		$view->set('heading_title', $language->get('heading_title'));
		$view->set('heading_description', $language->get('heading_description'));		

		$view->set('text_enabled', $language->get('text_enabled'));
		$view->set('text_disabled', $language->get('text_disabled'));
		
		$view->set('entry_status', $language->get('entry_status'));
		$view->set('entry_text_logged', $language->get('entry_text_logged'));
		$view->set('entry_text_greeting', $language->get('entry_text_greeting'));

		$view->set('button_save', $language->get('button_save'));
		$view->set('button_cancel', $language->get('button_cancel'));

		$view->set('tab_general', $language->get('tab_general'));

		$view->set('error', @$this->error['message']);

		$view->set('action', $url->ssl('module_catalog_welcome'));
		
		$view->set('list', $url->ssl('extension', FALSE, array('type' => 'module')));

		$view->set('cancel', $url->ssl('extension', FALSE, array('type' => 'module')));	

		if (!$request->isPost()) {
			$results = $database->getRows("select * from setting where type = 'catalog' and `group` = 'welcome'");
			
			foreach ($results as $result) {
				$setting_info[$result['type']][$result['key']] = $result['value'];
			}
		}
		
		if ($request->has('catalog_welcome_status', 'post')) {
			$view->set('catalog_welcome_status', $request->gethtml('catalog_welcome_status', 'post'));
		} else {
			$view->set('catalog_welcome_status', @$setting_info['catalog']['welcome_status']);
		}

		if ($request->has('catalog_welcome_text_logged', 'post')) {
			$view->set('catalog_welcome_text_logged', $request->gethtml('catalog_welcome_text_logged', 'post'));
		} else {
			$view->set('catalog_welcome_text_logged', isset($setting_info['catalog']['welcome_text_logged'])?htmlspecialchars($setting_info['catalog']['welcome_text_logged']):NULL);
		}

		if ($request->has('catalog_welcome_text_greeting', 'post')) {
			$view->set('catalog_welcome_text_greeting', $request->gethtml('catalog_welcome_text_greeting', 'post'));
		} else {
			$view->set('catalog_welcome_text_greeting', isset($setting_info['catalog']['welcome_text_greeting'])?htmlspecialchars($setting_info['catalog']['welcome_text_greeting']):NULL);
		}
									
		$template->set('content', $view->fetch('content/module_catalog_welcome.tpl'));

		$template->set($module->fetch());

		$response->set($template->fetch('layout.tpl'));
	}
	
	function validate() {
		$language =& $this->locator->get('language');
		$user     =& $this->locator->get('user');

		if (!$user->hasPermission('modify', 'module_catalog_welcome')) {
			$this->error['message'] = $language->get('error_permission');
		}
		
		if (!$this->error) {
			return TRUE;
		} else {
			return FALSE;
		}	
	}
	
	function install() {
		$database =& $this->locator->get('database');
		$language =& $this->locator->get('language');
		$response =& $this->locator->get('response');
		$session  =& $this->locator->get('session');
		$url      =& $this->locator->get('url');
		$user     =& $this->locator->get('user');
		
		$language->load('controller/module_catalog_welcome.php');
		
		if ($user->hasPermission('modify', 'module_catalog_welcome')) {
			$database->query("delete from setting where type = 'catalog' and `group` = 'welcome'");
			
			$database->query("insert into setting set type = 'catalog', `group` = 'welcome', `key` = 'welcome_status', value = '1'");
			
			$session->set('message', $language->get('text_message'));
		} else {
			$session->set('error', $language->get('error_permission'));
		}	
				
		$response->redirect($url->ssl('extension', FALSE, array('type' => 'module')));	
	}
	
	function uninstall() {
		$database =& $this->locator->get('database');
		$language =& $this->locator->get('language');
		$response =& $this->locator->get('response');
		$session  =& $this->locator->get('session');
		$url      =& $this->locator->get('url');
		$user     =& $this->locator->get('user');
		
		$language->load('controller/module_catalog_welcome.php');
		
		if ($user->hasPermission('modify', 'module_catalog_welcome')) {
			$database->query("delete from setting where type = 'catalog' and `group` = 'welcome'");
			
			$session->set('message', $language->get('text_message'));
		} else {
			$session->set('error', $language->get('error_permission'));
		}	
				
		$response->redirect($url->ssl('extension', FALSE, array('type' => 'module')));
	}
}
?>
