<?php
class ControllerReportViewed extends Controller {
	function index() {   
		$response =& $this->locator->get('response');
		$database =& $this->locator->get('database');
		$url      =& $this->locator->get('url');
		$language =& $this->locator->get('language');
		$session  =& $this->locator->get('session');
		$template =& $this->locator->get('template');
		$module   =& $this->locator->get('module');

		$language->load('controller/report_viewed.php');

		$template->set('title', $language->get('heading_title'));
 
		$view = $this->locator->create('template');

		$view->set('tpl', $template);

		$view->set('heading_title', $language->get('heading_title'));
		$view->set('heading_description', $language->get('heading_description'));
 		
		$view->set('column_name', $language->get('column_name'));
		$view->set('column_viewed', $language->get('column_viewed'));
		$view->set('column_percent', $language->get('column_percent'));
		
		$view->set('button_reset', $language->get('button_reset'));
		$view->set('message', $session->get('message'));
		
		$session->delete('message');
		
		$product_data = array();
		
		$results = $database->getRows("select * from product p left join product_description pd on (p.product_id = pd.product_id) where pd.language_id = '" . (int)$language->getId() . "' order by viewed desc");
		
		$total = 0;
		
		foreach ($results as $result) {
			$total += $result['viewed'];
		}
		
		foreach ($results as $result) {
			$percent=$total?round(($result['viewed'] / $total) * 100, 2):0;
			$product_data[] = array(
				'name'    => $result['name'],
				'viewed'  => $result['viewed'],
				'percent' => str_replace($language->get('decimal_point'),'.',($percent.'%'))
			);
		}
		
		$view->set('products', $product_data);
		
		$view->set('action', $url->ssl('report_viewed', 'resetCount'));
		
		$template->set('content', $view->fetch('content/report_viewed.tpl'));

		$template->set($module->fetch());

		$response->set($template->fetch('layout.tpl'));
	}
	
	function resetCount() {   
		$response =& $this->locator->get('response');
		$database =& $this->locator->get('database');
		$url      =& $this->locator->get('url');
		$language =& $this->locator->get('language');
		$template =& $this->locator->get('template');
		$session  =& $this->locator->get('session');
		$module   =& $this->locator->get('module');

		$language->load('controller/report_viewed.php');

		$template->set('title', $language->get('heading_title'));
		
		$database->query("update product set viewed = '0'");
		
		$session->set('message', $language->get('text_reset_message'));
		
		$response->redirect($url->ssl('report_viewed'));
	}
}
?>
