#Version Setting
SET @ver='0.8.1';
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `type` = 'global' and `group` = 'version' and `key` = 'version';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'global', 'version', 'version', @ver) ON DUPLICATE KEY UPDATE value=@ver;

#Allow up to 5 char for language code. (ie en_US)
#ALTER TABLE `language` CHANGE `code` `code` VARCHAR(5);

#Added to correct the sort order based on the way they are calculated
UPDATE `setting` SET `value` = '3' WHERE `key`='coupon_sort_order';
UPDATE `setting` SET `value` = '4' WHERE `key`='tax_sort_order';

#Change to allow proper rounding in mysql tables
ALTER TABLE `currency` CHANGE `value` `value` DOUBLE( 13, 8 ) NULL DEFAULT NULL;

#Added to support ipv6
ALTER TABLE `order` CHANGE `ip` `ip` VARCHAR( 39 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;
ALTER TABLE `session` CHANGE `ip` `ip` VARCHAR( 39 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;
ALTER TABLE `user` CHANGE `ip` `ip` VARCHAR( 39 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;
ALTER TABLE `customer` CHANGE `ip` `ip` VARCHAR( 39 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL;

#Added to update the gram to xxx weight rule from all zeroes to actual values
UPDATE `weight_rule` SET `rule` = '0.0010' WHERE `weight_rule`.`from_id` =1 AND `weight_rule`.`to_id` =2 AND CONCAT( `weight_rule`.`rule` ) = 0.0000 LIMIT 1 ;
UPDATE `weight_rule` SET `rule` = '0.0353' WHERE `weight_rule`.`from_id` =1 AND `weight_rule`.`to_id` =3 AND CONCAT( `weight_rule`.`rule` ) = 0.0000 LIMIT 1 ;
UPDATE `weight_rule` SET `rule` = '0.0022' WHERE `weight_rule`.`from_id` =1 AND `weight_rule`.`to_id` =4 AND CONCAT( `weight_rule`.`rule` ) = 0.0000 LIMIT 1 ;

#Added to insert the new Paid Unconfirmed order status
SET @id=NULL;
SELECT @id:=order_status_id FROM order_status WHERE `name` = 'Paid Unconfirmed';
INSERT INTO `order_status` (`order_status_id`, `language_id`,`name`) VALUES (@id,'1','Paid Unconfirmed') ON DUPLICATE KEY UPDATE order_status_id=order_status_id;

#Added to split the language between admin & catalog (issue 92)
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `type` = 'catalog' and `key` = 'config_language';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'config', 'config_language', 'en') ON DUPLICATE KEY UPDATE setting_id=setting_id;

SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `type` = 'admin' and `key` = 'config_language';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'admin', 'config', 'config_language', 'en') ON DUPLICATE KEY UPDATE setting_id=setting_id;

#Added to add new min_qty column to the product table. 
ALTER TABLE `product` ADD `min_qty` int(4) NOT NULL default '1' AFTER `quantity`;

#Added admin language module disabled by default
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `type` = 'admin' and `key` = 'language_status';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'admin', 'language', 'language_status', '0') ON DUPLICATE KEY UPDATE setting_id=setting_id;
SET @id=NULL;
SELECT @id:=extension_id FROM extension WHERE `controller` = 'module_admin_language';
INSERT INTO `extension` (`extension_id`, `code`, `type`, `directory`, `filename`, `controller`) VALUES (@id, 'language', 'module', 'module', 'language.php', 'module_admin_language') ON DUPLICATE KEY UPDATE extension_id=extension_id;
SET @id=NULL;
SELECT @id:=extension_id FROM extension WHERE `controller` = 'module_admin_language';
INSERT INTO `extension_description` (`extension_id`, `language_id`, `name`, `description`) VALUES (@id, '1', 'Admin Language', 'Admin Language') ON DUPLICATE KEY UPDATE extension_id=extension_id;

#Added new paypal configuration for selecting 'authorization' or 'sale'.
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'paypal' and `key` = 'paypal_auth_type';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'global', 'paypal', 'paypal_auth_type', 'sale') ON DUPLICATE KEY UPDATE setting_id=setting_id;

#Added category description mod to the core
ALTER TABLE `category_description` ADD `description` TEXT NULL ;

#Setting values need to be longer
ALTER TABLE `setting` CHANGE `value` `value` VARCHAR( 256 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;

#Added "latest" module for home page
SET @id=NULL;
SELECT @id:=extension_id FROM `extension` WHERE `code` = 'latest' and `controller` = 'module_catalog_latest';
INSERT INTO `extension` (`extension_id`, `code`, `type`, `directory`, `filename`, `controller`) VALUES (@id, 'latest', 'module', 'module', 'latest.php', 'module_catalog_latest') ON DUPLICATE KEY UPDATE extension_id=extension_id;
SELECT @id:=extension_id FROM `extension` WHERE `code` = 'latest' and `controller` = 'module_catalog_latest';
INSERT INTO `extension_description` (`extension_id`, `language_id`, `name`, `description`) VALUES (@id, '1', 'Home Latest', 'Home Latest') ON DUPLICATE KEY UPDATE extension_id=extension_id;

#Install "latest" module for home page
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'latest' and `key` = 'latest_status';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'latest', 'latest_status', '1') ON DUPLICATE KEY UPDATE setting_id=setting_id;
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'latest', 'latest_limit', '8') ON DUPLICATE KEY UPDATE setting_id=setting_id;
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'latest', 'latest_image_width', '120') ON DUPLICATE KEY UPDATE setting_id=setting_id;
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'latest', 'latest_image_height', '120') ON DUPLICATE KEY UPDATE setting_id=setting_id;
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'latest', 'latest_atc', '1') ON DUPLICATE KEY UPDATE setting_id=setting_id;
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'latest', 'latest_max_desc', '80') ON DUPLICATE KEY UPDATE setting_id=setting_id;
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'latest', 'latest_columnizer', '1') ON DUPLICATE KEY UPDATE setting_id=setting_id;
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'latest', 'latest_cpr', '4') ON DUPLICATE KEY UPDATE setting_id=setting_id;

#Added "welcome" module for home page
SET @id=NULL;
SELECT @id:=extension_id FROM `extension` WHERE `code` = 'welcome' and `controller` = 'module_catalog_welcome';
INSERT INTO `extension` (`extension_id`, `code`, `type`, `directory`, `filename`, `controller`) VALUES (@id, 'welcome', 'module', 'module', 'welcome.php', 'module_catalog_welcome') ON DUPLICATE KEY UPDATE extension_id=extension_id;
SELECT @id:=extension_id FROM `extension` WHERE `code` = 'welcome' and `controller` = 'module_catalog_welcome';
INSERT INTO `extension_description` (`extension_id`, `language_id`, `name`, `description`) VALUES (@id, '1', 'Home Welcome', 'Home Welcome') ON DUPLICATE KEY UPDATE extension_id=extension_id;

#Added "popular" module for home page
SET @id=NULL;
SELECT @id:=extension_id FROM `extension` WHERE `code` = 'popular' and `controller` = 'module_catalog_popular';
INSERT INTO `extension` (`extension_id`, `code`, `type`, `directory`, `filename`, `controller`) VALUES (@id, 'popular', 'module', 'module', 'popular.php', 'module_catalog_popular') ON DUPLICATE KEY UPDATE extension_id=extension_id;
SELECT @id:=extension_id FROM `extension` WHERE `code` = 'popular' and `controller` = 'module_catalog_popular';
INSERT INTO `extension_description` (`extension_id`, `language_id`, `name`, `description`) VALUES (@id, '1', 'Home Popular', 'Home Popular') ON DUPLICATE KEY UPDATE extension_id=extension_id;

#Added "featured" module for home page
SET @id=NULL;
SELECT @id:=extension_id FROM `extension` WHERE `code` = 'featured' and `controller` = 'module_catalog_featured';
INSERT INTO `extension` (`extension_id`, `code`, `type`, `directory`, `filename`, `controller`) VALUES (@id, 'featured', 'module', 'module', 'featured.php', 'module_catalog_featured') ON DUPLICATE KEY UPDATE extension_id=extension_id;
SELECT @id:=extension_id FROM `extension` WHERE `code` = 'featured' and `controller` = 'module_catalog_featured';
INSERT INTO `extension_description` (`extension_id`, `language_id`, `name`, `description`) VALUES (@id, '1', 'Home Featured', 'Home Featured') ON DUPLICATE KEY UPDATE extension_id=extension_id;

#Added new config_email_send_order setting
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `type` = 'catalog' and `key` = 'config_email_send_order';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'config', 'config_email_send_order', 1) ON DUPLICATE KEY UPDATE setting_id=setting_id;

#Added new config_email_account_create setting
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `type` = 'catalog' and `key` = 'config_email_send_account_create';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'config', 'config_email_send_account_create', 0) ON DUPLICATE KEY UPDATE setting_id=setting_id;

#Make Product name longer
ALTER TABLE `product_description` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;

#Make Category name longer
ALTER TABLE `category_description` CHANGE `name` `name` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;

#Add "maintenance" configuration option
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'config' and `key` = 'config_maintenance';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'global', 'config', 'config_maintenance', '0') ON DUPLICATE KEY UPDATE setting_id=setting_id;

#Convert "English" to 'en-gb' (be sure to test upgrade with stores that have other full length languages
UPDATE `language` SET `name` = 'en-gb', `code` = 'en-gb', `image` = 'gb.png', `directory` = 'en-gb', `filename` = 'en-gb.php' WHERE `code` = 'en';
UPDATE `setting` SET `value` = 'en-gb' WHERE `key` = 'config_language';
UPDATE `setting` SET `value` = 'en-gb' WHERE `key` = 'admin_language';

#Add status to Country for populating country lists
ALTER TABLE `country` ADD `status` INT( 1 ) NOT NULL DEFAULT '1';

#Add status to Information
ALTER TABLE `information` ADD `status` INT( 1 ) NOT NULL DEFAULT '1';

#Make product.model longer
ALTER TABLE `product` CHANGE `model` `model` VARCHAR( 32 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL;
ALTER TABLE `order_product` CHANGE `model` `model` VARCHAR( 32 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NULL DEFAULT NULL;

#Added custom image sizes
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'config' and `key` = 'config_image_width_product';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (NULL, 'catalog', 'config', 'config_image_width_product', '250') ON DUPLICATE KEY UPDATE setting_id=setting_id;
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'config' and `key` = 'config_image_height_product';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (NULL, 'catalog', 'config', 'config_image_height_product', '250') ON DUPLICATE KEY UPDATE setting_id=setting_id;
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'config' and `key` = 'config_image_width_category';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (NULL, 'catalog', 'config', 'config_image_width_category', '125') ON DUPLICATE KEY UPDATE setting_id=setting_id;
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'config' and `key` = 'config_image_height_category';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (NULL, 'catalog', 'config', 'config_image_height_category', '125') ON DUPLICATE KEY UPDATE setting_id=setting_id;
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'config' and `key` = 'config_image_width_images';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (NULL, 'catalog', 'config', 'config_image_width_images', '100') ON DUPLICATE KEY UPDATE setting_id=setting_id;
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'config' and `key` = 'config_image_height_images';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (NULL, 'catalog', 'config', 'config_image_height_images', '100') ON DUPLICATE KEY UPDATE setting_id=setting_id;
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'config' and `key` = 'config_image_width_related';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (NULL, 'catalog', 'config', 'config_image_width_related', '100') ON DUPLICATE KEY UPDATE setting_id=setting_id;
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'config' and `key` = 'config_image_height_related';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (NULL, 'catalog', 'config', 'config_image_height_related', '100') ON DUPLICATE KEY UPDATE setting_id=setting_id;

#Added Ajax Add to Cart options
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'config' and `key` = 'config_ajaxadd';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (NULL, 'catalog', 'config', 'config_ajaxadd', '1') ON DUPLICATE KEY UPDATE setting_id=setting_id;

#Added new specials manager
CREATE TABLE IF NOT EXISTS `product_special` (
  `special_id` int(11) NOT NULL auto_increment,
  `product_id` int(11) NOT NULL default '0',
  `discount` decimal(15,4) NOT NULL,
  `prefix` varchar(1) collate utf8_unicode_ci NOT NULL,
  `date_start` datetime NOT NULL,
  `date_end` datetime NOT NULL,
  `status` int(1) NOT NULL,
  PRIMARY KEY  (`special_id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

#Added "special" module for home page
SET @id=NULL;
SELECT @id:=extension_id FROM `extension` WHERE `code` = 'special' and `controller` = 'module_catalog_special';
INSERT INTO `extension` (`extension_id`, `code`, `type`, `directory`, `filename`, `controller`) VALUES (@id, 'special', 'module', 'module', 'special.php', 'module_catalog_special') ON DUPLICATE KEY UPDATE extension_id=extension_id;
SELECT @id:=extension_id FROM `extension` WHERE `code` = 'special' and `controller` = 'module_catalog_special';
INSERT INTO `extension_description` (`extension_id`, `language_id`, `name`, `description`) VALUES (@id, '1', 'Home Special', 'Home Special') ON DUPLICATE KEY UPDATE extension_id=extension_id;

#Install "special" module for home page
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'special' and `key` = 'special_status';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'special', 'special_status', '1') ON DUPLICATE KEY UPDATE setting_id=setting_id;
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'special', 'special_limit', '4') ON DUPLICATE KEY UPDATE setting_id=setting_id;
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'special', 'special_image_width', '120') ON DUPLICATE KEY UPDATE setting_id=setting_id;
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'special', 'special_image_height', '120') ON DUPLICATE KEY UPDATE setting_id=setting_id;
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'special', 'special_atc', '1') ON DUPLICATE KEY UPDATE setting_id=setting_id;
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'special', 'special_max_desc', '0') ON DUPLICATE KEY UPDATE setting_id=setting_id;
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'special', 'special_columnizer', '1') ON DUPLICATE KEY UPDATE setting_id=setting_id;
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'special', 'special_cpr', '4') ON DUPLICATE KEY UPDATE setting_id=setting_id;


#Add configurable session expire time.
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'config' and `key` = 'config_session_expire';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'global', 'config', 'config_session_expire', '3600') ON DUPLICATE KEY UPDATE setting_id=setting_id;

#Add configurable email authentication
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'config' and `key` = 'config_email_authentication';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'global', 'config', 'config_email_authentication', '0') ON DUPLICATE KEY UPDATE setting_id=setting_id;

#Add status to category
ALTER TABLE `category` ADD `status` INT( 1 ) NOT NULL DEFAULT '1';

#Added "best" module for home page
SET @id=NULL;
SELECT @id:=extension_id FROM `extension` WHERE `code` = 'best' and `controller` = 'module_catalog_best';
INSERT INTO `extension` (`extension_id`, `code`, `type`, `directory`, `filename`, `controller`) VALUES (@id, 'best', 'module', 'module', 'best.php', 'module_catalog_best') ON DUPLICATE KEY UPDATE extension_id=extension_id;
SELECT @id:=extension_id FROM `extension` WHERE `code` = 'best' and `controller` = 'module_catalog_best';
INSERT INTO `extension_description` (`extension_id`, `language_id`, `name`, `description`) VALUES (@id, '1', 'Best Seller', 'Best Seller') ON DUPLICATE KEY UPDATE extension_id=extension_id;

#Install "best" module for home page
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'best' and `key` = 'best_status';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'best', 'best_status', '1') ON DUPLICATE KEY UPDATE setting_id=setting_id;
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'best', 'best_max_cols', '3') ON DUPLICATE KEY UPDATE setting_id=setting_id;
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'best', 'best_limit', '6') ON DUPLICATE KEY UPDATE setting_id=setting_id;

#Uninstall old static admin menu
delete from `setting` where `type` = 'admin' and `group` = 'menu';

#Add New DB Admin Menu
CREATE TABLE IF NOT EXISTS `admenu` (
    `menu_id` int NOT NULL auto_increment,
    `parent_id` int (11),
    `title` varchar (36),
    `icon` varchar (36),
    `href` varchar (384),
    `status` int(1),
    `language_id` int(11) NOT NULL default '1',
    `sort_order` int(11) NOT NULL,
     PRIMARY KEY  (`menu_id`)
) TYPE=MyISAM;


##Admin Category
insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(1,0,'Admin',NULL,NULL,1,1,1) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(2,1,'Home','home.png','index.php?controller=home',1,1,1) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(3,1,'Catalog','shop.png','../index.php" target="_blank',1,1,2) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(4,1,'Configuration','configuration.png',NULL,1,1,3) ON DUPLICATE KEY UPDATE menu_id=menu_id;
    insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(5,4,'Setting','setting.png','index.php?controller=setting',1,1,1) ON DUPLICATE KEY UPDATE menu_id=menu_id;
    insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(6,4,'Users','users.png',NULL,1,1,2) ON DUPLICATE KEY UPDATE menu_id=menu_id;
      insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(7,6,'User','user.png','index.php?controller=user',1,1,1) ON DUPLICATE KEY UPDATE menu_id=menu_id;
      insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(8,6,'User Group','user_group.png','index.php?controller=user_group',1,1,2) ON DUPLICATE KEY UPDATE menu_id=menu_id;
    insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(9,4,'Localization','localisation.png',NULL,1,1,3) ON DUPLICATE KEY UPDATE menu_id=menu_id;
      insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(10,9,'Language','language.png','index.php?controller=language',1,1,1) ON DUPLICATE KEY UPDATE menu_id=menu_id;
      insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(11,9,'Currency','currency.png','index.php?controller=currency',1,1,2) ON DUPLICATE KEY UPDATE menu_id=menu_id;
      insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(12,9,'Order Status','order_status.png','index.php?controller=order_status',1,1,3) ON DUPLICATE KEY UPDATE menu_id=menu_id;
      insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(13,9,'Country','country.png','index.php?controller=country',1,1,4) ON DUPLICATE KEY UPDATE menu_id=menu_id;
      insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(14,9,'Zone','zone.png','index.php?controller=zone',1,1,5) ON DUPLICATE KEY UPDATE menu_id=menu_id;
      insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(15,9,'Geo Zone','geo_zone.png','index.php?controller=geo_zone',1,1,6) ON DUPLICATE KEY UPDATE menu_id=menu_id;
      insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(16,9,'Tax Class','tax_class.png','index.php?controller=tax_class',1,1,7) ON DUPLICATE KEY UPDATE menu_id=menu_id;
      insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(17,9,'Weight Class','weight_class.png','index.php?controller=weight_class',1,1,8) ON DUPLICATE KEY UPDATE menu_id=menu_id;
    insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(18,4,'URL Alias','url_alias.png','index.php?controller=url_alias',1,1,4) ON DUPLICATE KEY UPDATE menu_id=menu_id;
    insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(19,4,'SQL Backup-Restore','backup.png','index.php?controller=backup',1,1,5) ON DUPLICATE KEY UPDATE menu_id=menu_id;
    insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(20,4,'Server Info','server_info.png','index.php?controller=server_info',1,1,6) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(21,1,'Logout','logout.png','index.php?controller=logout',1,1,999) ON DUPLICATE KEY UPDATE menu_id=menu_id;

##Catalog Category
insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(22,0,'Catalog',NULL,NULL,1,1,2) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(23,22,'Category','category.png','index.php?controller=category',1,1,1) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(24,22,'Product','product.png','index.php?controller=product',1,1,2) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(25,22,'Option','option.png','index.php?controller=option',1,1,3) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(47,22,'Special','currency.png','index.php?controller=product_special',1,1,3) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(26,22,'Manufacturer','manufacturer.png','index.php?controller=manufacturer',1,1,4) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(27,22,'Image','image.png','index.php?controller=image',1,1,5) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(28,22,'Download','download.png','index.php?controller=download',1,1,6) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(29,22,'Review','review.png','index.php?controller=review',1,1,7) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(30,22,'Information','information.png','index.php?controller=information',1,1,8) ON DUPLICATE KEY UPDATE menu_id=menu_id;

##Extensions Category
insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(31,0,'Extensions',NULL,NULL,1,1,3) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(32,31,'Module','module.png','index.php?controller=extension&type=module',1,1,1) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(33,31,'Shipping','shipping.png','index.php?controller=extension&type=shipping',1,1,2) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(34,31,'Payment','payment.png','index.php?controller=extension&type=payment',1,1,3) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(35,31,'Calculate','calculate.png','index.php?controller=extension&type=calculate',1,1,4) ON DUPLICATE KEY UPDATE menu_id=menu_id;

##Customers Category
insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(36,0,'Customers',NULL,NULL,1,1,4) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(37,36,'Customer','customer.png','index.php?controller=customer',1,1,1) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(38,36,'Order','order.png','index.php?controller=order',1,1,2) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(39,36,'Coupon','coupon.png','index.php?controller=coupon',1,1,3) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(40,36,'Mail','mail.png','index.php?controller=mail',1,1,4) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(41,36,'Newsletter','newsletter.png','index.php?controller=newsletter',1,1,5) ON DUPLICATE KEY UPDATE menu_id=menu_id;

##Reports Category  
insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(42,0,'Reports',NULL,NULL,1,1,5) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(43,42,'People Online','report.png','index.php?controller=report_online',1,1,1) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(44,42,'Sales','report.png','index.php?controller=report_sale',1,1,2) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(45,42,'Products Viewed','report.png','index.php?controller=report_viewed',1,1,3) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(46,42,'Products Purchased','report.png','index.php?controller=report_purchased',1,1,4) ON DUPLICATE KEY UPDATE menu_id=menu_id;

##Help Category  
insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(48,0,'Help',NULL,NULL,1,1,6) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(49,48,'Main Site','help.png','http://chromiumcart.com',1,1,1) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(52,48,'Get Addons','help.png','http://forum.chromiumcart.com/index.php?action=downloads',1,1,2) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(50,48,'Support Forum','help.png','http://forum.chromiumcart.com',1,1,3) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(51,48,'FAQ','help.png','http://forum.chromiumcart.com/index.php/board,29.0.html',1,1,4) ON DUPLICATE KEY UPDATE menu_id=menu_id;
  insert into `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(53,48,'Wiki','help.png','http://wiki.chromiumcart.com',1,1,5) ON DUPLICATE KEY UPDATE menu_id=menu_id;
 
#Install new Admin DB menu
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'topmenu' and `key` = 'topmenu_status';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'admin', 'topmenu', 'topmenu_status', '1') ON DUPLICATE KEY UPDATE setting_id=setting_id;

#Force "base" catalog template since old templates aren't compatible.
UPDATE `setting` SET `value` = 'base' WHERE `type`='catalog' and `key`='config_template';

#Force "base" admin template to ensure new menu and button bar are used.
UPDATE `setting` SET `value` = 'base' WHERE `type`='admin' and `key`='config_template';

#Added Meta support
CREATE TABLE IF NOT EXISTS`product_meta` (
  `product_id` int(11) NOT NULL auto_increment,
  `language_id` int(11) NOT NULL default '1',
  `keywords` varchar(255) collate utf8_unicode_ci NOT NULL,
  `description` text collate utf8_unicode_ci,
  PRIMARY KEY  (`product_id`,`language_id`),
  KEY `name` (`keywords`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1 ;

#Default store wide meta
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'config' and `key` = 'config_meta_keys_store';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'global', 'config', 'config_meta_keys_store', 'chromiumcart, chromium, cart, e-commerce, ecommerce, open source, opencart, zencart') ON DUPLICATE KEY UPDATE setting_id=setting_id;
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'config' and `key` = 'config_meta_description_store';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'global', 'config', 'config_meta_description_store', 'ChromiumCart. A New Open Source E-commerce platform built from the ground up using MVC framework. Easy enough to use for beginners, yet powerful enough for advanced developers.') ON DUPLICATE KEY UPDATE setting_id=setting_id;


#Added Related Products
CREATE TABLE IF NOT EXISTS `product_related` (
  `product_id` int(11) NOT NULL,
  `related_id` int(11) NOT NULL,
  PRIMARY KEY  (`product_id`,`related_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

#Added "navbar" module
SET @id=NULL;
SELECT @id:=extension_id FROM `extension` WHERE `code` = 'navbar' and `controller` = 'module_catalog_navbar';
INSERT INTO `extension` (`extension_id`, `code`, `type`, `directory`, `filename`, `controller`) VALUES (@id, 'navbar', 'module', 'module', 'navbar.php', 'module_catalog_navbar') ON DUPLICATE KEY UPDATE extension_id=extension_id;
SELECT @id:=extension_id FROM `extension` WHERE `code` = 'navbar' and `controller` = 'module_catalog_navbar';
INSERT INTO `extension_description` (`extension_id`, `language_id`, `name`, `description`) VALUES (@id, '1', 'Catalog Navbar', 'Catalog Navbar') ON DUPLICATE KEY UPDATE extension_id=extension_id;

#Install "navbar" module for home page
SET @id=NULL;
SELECT @id:=setting_id FROM setting WHERE `group` = 'navbar' and `key` = 'navbar_status';
INSERT INTO `setting` (`setting_id`, `type`, `group`, `key`, `value`) VALUES (@id, 'catalog', 'navbar', 'navbar_status', '1') ON DUPLICATE KEY UPDATE setting_id=setting_id;

#--- ChromiumCart 0.8.0 Released - July 1st 2009 ---#

#Add CC fields to order table for new offline cc and future cc support:
ALTER TABLE `order` ADD `cc_type` VARCHAR( 16 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT "",
ADD `cc_name` VARCHAR( 64 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT "",
ADD `cc_number` VARCHAR( 20 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT "",
ADD `cc_exp` VARCHAR( 8 ) CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL DEFAULT "",
ADD `cc_cvv` INT( 6 ) NOT NULL DEFAULT '0';

#Alter admenu to make menu_id & language_id as primary to allow multi-lingual entries
ALTER TABLE `admenu` DROP PRIMARY KEY ,
ADD PRIMARY KEY ( `menu_id` , `language_id` )

#Add wiki link to admenu for upgraders from v080
SET @id=NULL;
SELECT @id:=menu_id FROM admenu WHERE `title` = 'Wiki';
INSERT INTO `admenu` (`menu_id`, `parent_id`, `title`, `icon`, `href`, `status`, `language_id`, `sort_order`) values(@id,48,'Wiki','help.png','http://wiki.chromiumcart.com',1,1,5) ON DUPLICATE KEY UPDATE menu_id=menu_id;

#Point to correct url for help menu
update admenu SET `href` = replace(`href`, "opencart0.com", "chromiumcart.com");