<?php
class Request {					        
  	function get($key, $type = 'GET', $default = NULL) {
		switch (strtoupper($type)) {
			case 'GET':
				return (isset($_GET[$key]) ? $_GET[$key] : $default);
				break;
			case 'POST':
				return (isset($_POST[$key]) ? $_POST[$key] : $default);
				break;
			case 'REQUEST':
				return (isset($_REQUEST[$key]) ? $_REQUEST[$key] : $default);
				break;
			case 'COOKIE':
				return (isset($_COOKIE[$key]) ? $_COOKIE[$key] : $default);
				break;
		}
	}

  	function gethtml($key, $type = 'GET', $default = NULL) {
		return htmlspecialchars_deep($this->get($key,$type,$default));
	}
    
	function has($key, $type = 'GET') {
		switch (strtoupper($type)) {
			case 'GET':
				return isset($_GET[$key]);
				break;
			case 'POST':
				return isset($_POST[$key]);
				break;
			case 'REQUEST':
				return isset($_REQUEST[$key]);
				break;
			case 'COOKIE':
				return isset($_COOKIE[$key]); 
				break;
		}	
	}
	
	function set($key, $value, $type = 'GET') {
		switch (strtoupper($type)) {
			case 'GET':
				return $_GET[$key] = $value;
				break;
			case 'POST':
				return $_POST[$key] = $value;
				break;
			case 'REQUEST':
				return $_REQUEST[$key] = $value;
				break;
		}	
	}
	
	function isPost() {
		return (strtoupper($_SERVER['REQUEST_METHOD']) == 'POST');
	}

	function isSecure() {
		return (isset($_SERVER['HTTPS']))?true:false;
	}
}
?>